<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Dependabot Gitlab</title>
  </head>

  <style>
  body {
    margin: 8px 32px;
    font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, "Noto Sans", Ubuntu, Cantarell, "Helvetica Neue", sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol", "Noto Color Emoji";
    font-size: 14px;
  }
  a.version {
    position: absolute;
    top: 0;
    right: 0;
  }
  form > * {
    display: block;
    margin-top: 8px;
  }
  button, input {
    font-size: 14px;
    border-radius: 0.25rem;
    border: none;
    box-shadow: inset 0 0 0 1px #89888d;
    padding: 8px 12px;
  }
  button,
  input[type=submit] {
    background-color: #1f75cb;
    box-shadow: inset 0 0 0 1px #1068bf;
    color: #fff;
  }
  header {
    display: flex;
    align-items: baseline;
    justify-content: space-between;
  }
  table.blueTable {
    border: 1px solid #1C6EA4;
    background-color: #EEEEEE;
    width: 100%;
    text-align: left;
    border-collapse: collapse;
  }
  table.blueTable td, table.blueTable th {
    border: 1px solid #AAAAAA;
    padding: 3px 2px;
  }
  table.blueTable tbody td {
    font-size: 13px;
  }
  table.blueTable tr:nth-child(even) {
    background: #D0E4F5;
  }
  table.blueTable thead {
    background: #1C6EA4;
    background: -moz-linear-gradient(top, #5592bb 0%, #327cad 66%, #1C6EA4 100%);
    background: -webkit-linear-gradient(top, #5592bb 0%, #327cad 66%, #1C6EA4 100%);
    background: linear-gradient(to bottom, #5592bb 0%, #327cad 66%, #1C6EA4 100%);
    border-bottom: 2px solid #444444;
  }
  table.blueTable thead th {
    font-size: 15px;
    color: #FFFFFF;
    border-left: 2px solid #D0E4F5;
  }
  table.blueTable thead th:first-child {
    border-left: none;
  }
  </style>

  <body>
    <a class="version" href="https://dependabot-gitlab.gitlab.io/dependabot"><%= "v#{version}"%></a>
    <h1>Projects</h1>

    <%= form_with url: project_add_path, method: :put do |form| %>
      <%= form.label :project_name, "Project path to add:" %>
      <%= form.text_field :project_name %>
      <%= form.label :access_token, "Access token: (optional)" %>
      <%= form.text_field :access_token %>
      <%= form.submit "Add" %>
    <% end %>

    <% flash.each do |type, msg| %>
      <p>
        <strong><%= type %></strong>: <%= msg %>
      </p>
    <% end %>

    <% @projects.each do |project| %>
      <header>
        <h2><%= link_to_if project.web_url, project.name, project.web_url %></h2>
        <%= button_to "Sync", project_update_path(project.id), method: "put", title: "Sync project configuration" %>
      </header>

      <table class="blueTable">
        <thead>
          <tr>
            <th>Package ecosystem</th>
            <th>Directory</th>
            <th>Cron</th>
            <th>Last executed</th>
            <th>Last execution errors</th>
            <th>Open merge requests</th>
            <th>Actions</th>
          </tr>
        </thead>

        <tbody>
          <% project.update_jobs.each do |job| %>
            <tr>
              <td><%= job.package_ecosystem %></td>
              <td><%= job.directory %></td>
              <td><%= job.cron %></td>
              <td><%= job.last_executed&.to_formatted_s(:long) %>
              <td><%= job.runs.last&.failures&.map(&:message)&.join("\n") %></td>
              <td>
                <%=
                  mrs = open_merge_requests(project, job.package_ecosystem, job.directory).length
                  link_to_if(mrs > 0, mrs, open_mrs_url(project, job.package_ecosystem, job.directory))
                %>
              </td>
              <td>
                <%= button_to "Execute", job_execute_path(job.id), method: "put", title: "Execute job now" %>
              </td>
            </tr>
          <% end %>
        </tbody>
      </table>
    <% end %>
  </body>
</html>
